﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.ComponentModel.Composition;
using System.ComponentModel;
 
using XamGridFieldLayout;

//using UFP.LumberTrack.ViewModeling.Production.Management.Batch.Status.DataEventHandlers;
using System.Threading;
using XamGridFieldLayout.Data;

namespace XamGridFieldLayout
{
    public interface IApplicationSessionProperties { }
   


    /// <summary>
    /// Manages status changes for a batch of runs.
    /// </summary>
    public partial class BatchStatusViewModel 
    {
       

        /// <summary>
        /// The dataset that holds onscreen batch status information.
        /// </summary>
        private BatchStatusData m_DataBatchStatus;

       
            


        /// <summary>
        /// XamDataGrid will look for this.
        /// It is the outer batch (parent of all statuses)
        /// </summary>
        public BatchStatusData.BatchDataTable BatchForBinding 
        {
            get { return m_DataBatchStatus.Batch; }
        }


 
         



         



        /// <summary>
        /// Allows Linq ForEach on typed row collections.
        /// The syntax is a lot cleaner and this can be reused.
        /// IEnumerable generics don't have ForEach so we use a list.  
        /// Don't use this where performance may be a factor.
        /// http://blogs.msdn.com/b/mazhou/archive/2011/09/21/why-no-foreach-method-on-ienumerable-interfaces.aspx
        /// </summary>
        protected List<T> ListForEaching<T>(DataTable p_Table)
        { return p_Table.Rows.Cast<T>().ToList(); }









        /// <summary>
        /// Construct
        /// </summary>
        /// <param name="p_StatusTypeForCompletion">CSM, PRD, or RUN</param>
        public BatchStatusViewModel(
            IApplicationSessionProperties p_AppServerInfo,
            int p_BatchNumber,
            string p_StatusTypeForCompletion)
        {
            

            // Create the dataset for statuses
            m_DataBatchStatus = new BatchStatusData();

            

        }


       

        /// <summary>
        /// Reset and get new data from app server model.
        /// This blows away and resets just about everything
        /// on the screen.  The only thing that remains
        /// is the notation of the runs on which we've
        /// entered tolerance notes (m_RunsHavingToleranceNotes).
        /// </summary>
        public void ResetViewModelData()
        {
            // Clear original
            //m_DataOriginal.Clear();
            //m_DataOriginal.AcceptChanges();

            // Clear screen data
            m_DataBatchStatus.Clear();
            m_DataBatchStatus.AcceptChanges();

            string StrToLoad = @"<BatchStatusData xmlns=""http://tempuri.org/BatchStatusData.xsd"">
                          <Batch>
                            <OurRecId>0K2IF4D85M4XMS2M</OurRecId>
                            <BatchNumber>20010257</BatchNumber>
                            <BranchCode>E369</BranchCode>
                            <BatchMemberCount>2</BatchMemberCount>
                            <OldRawMd5 />
                          </Batch>
                          <Run>
                            <OurRecId>0K2IF4D35M4XJ71Q</OurRecId>
                            <RunNumber>20145166</RunNumber>
                            <BranchCode>E369</BranchCode>
                            <StatusTypeForCompletion>CSM</StatusTypeForCompletion>
                            <SelectedForCompletion>false</SelectedForCompletion>
                            <EnabledForSelection>true</EnabledForSelection>
                            <WorkCenter>089</WorkCenter>
                            <WorkCenterDesc>PANEL SAW</WorkCenterDesc>
                            <Shift>1</Shift>
                            <ShiftDesc>1st SHIFT</ShiftDesc>
                            <LocationCode>369A</LocationCode>
                            <LocationDesc>369A-369 A YARD</LocationDesc>
                            <RunDate>2014-10-16T00:00:00-04:00</RunDate>
                            <StatusCsm>W</StatusCsm>
                            <StatusPrd>W</StatusPrd>
                            <StatusRun>W</StatusRun>
                            <GainLossForDisplay>Gain/(Loss): 43.267 = 36.06 %</GainLossForDisplay>
                            <GainLossWarningMessage> WARNING! The variance is outside the tolerance of +/-  1.00%. Continue? </GainLossWarningMessage>
                            <GainLossOverTolerance>true</GainLossOverTolerance>
                            <GainLossOverToleranceDismissed>false</GainLossOverToleranceDismissed>
                            <GainLossOverToleranceNotesNeeded>true</GainLossOverToleranceNotesNeeded>
                            <BatchNumber>20010257</BatchNumber>
                            <OldRawMd5 />
                          </Run>
                          
                          <DisplayableWarning>
                            <RunNumber>20145166</RunNumber>
                            <BranchCode>E369</BranchCode>
                            <WarningMessage>Test</WarningMessage>
                          </DisplayableWarning>
                          <DisplayableError>
                            <RunNumber>20145166</RunNumber>
                            <BranchCode>E369</BranchCode>
                            <ErrorMessage>Test</ErrorMessage>
                          </DisplayableError>
                          <ContinuationConfirmation>
                            <RunNumber>20145166</RunNumber>
                            <BranchCode>E369</BranchCode>
                            <WarningMessage>Please review warnings.</WarningMessage>
                          </ContinuationConfirmation>
                        </BatchStatusData>";

            System.Xml.XmlDocument DocToLoad = new System.Xml.XmlDocument();
            DocToLoad.LoadXml(StrToLoad);

          
            // Not currently warning mode
            m_DataBatchStatus.ReadXml(new System.Xml.XmlNodeReader(DocToLoad)); //.XmlReader.Create(.Create(DocToLoad.ReadXml(new System.Xml.XmlDocument()(.ReadXml(.ReadXml
             

            //// Accept dataset changes
            //m_DataOriginal.AcceptChanges();
            m_DataBatchStatus.AcceptChanges();

 
        }









         
         
       
     


    }
}
