﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DataPresenter;
using XamGridFieldLayout;
using XamGridFieldLayout.Data;


namespace UFP.LumberTrack.Production.Management.Batch.Status
{

    


    /// <summary>
    /// Interaction logic for StatusBatchEdit.xaml
    /// </summary>
    public partial class StatusBatchEdit : UserControl
    {

        /// <summary>
        /// Better type for most purposes.
        /// </summary>
        private BatchStatusViewModel InheritedViewModelContext
        { get { return ((BatchStatusViewModel)this.DataContext); } }
        
        /// <summary>
        /// Construction.
        /// </summary>
        public StatusBatchEdit()
        {
            InitializeComponent();
        }


        /// <summary>
        /// Initialize by expanding
        /// We also set the active record if one is not currently set.
        /// </summary>
        private void InitializeRecordForRun(Infragistics.Windows.DataPresenter.Events.InitializeRecordEventArgs p_Args)
        {
            // Expand every record for run
            if (!p_Args.Record.IsExpanded) 
            { 
                // Set expanded for the run
                p_Args.Record.IsExpanded = true; 
            }
             
        }

        /// <summary>
        /// Initialize by expanding
        /// We also set the active record if one is not currently set.
        /// </summary>
        private void InitializeRecordForBatch(Infragistics.Windows.DataPresenter.Events.InitializeRecordEventArgs p_Args)
        {
            // Expand every record for run
            if (!p_Args.Record.IsExpanded) 
            { 
                // Set expanded for the run
                p_Args.Record.IsExpanded = true; 
            }

        }

 

        /// <summary>
        /// Handler to initialize records.
        /// </summary>
        private void m_Grid_InitializeRecord(object p_Sender, Infragistics.Windows.DataPresenter.Events.InitializeRecordEventArgs p_Args)
        {
            if(System.ComponentModel.DesignerProperties.GetIsInDesignMode(this)) return;

            DataRecord DataRecordObj = p_Args.Record as DataRecord;
            if(DataRecordObj == null) return;

            DataRowView DataRowViewObj = DataRecordObj.DataItem as DataRowView;
            if(DataRowViewObj == null) return;

            if(DataRowViewObj.Row.Table.TableName == "Batch")
            { InitializeRecordForBatch(p_Args); }

            if(DataRowViewObj.Row.Table.TableName == "Run")
            { InitializeRecordForRun(p_Args); }
            
            // Handled
            p_Args.Handled = true;
        }

        
        /// <summary>
        /// The data record presenter is loaded.
        /// This may happen at runtime or design-time to expand automatically.
        /// </summary>
        private void m_Grid_DataRecordPresenterLoaded(object p_Sender, RoutedEventArgs p_Args)  
        {
            DataRecordPresenter DataRecordSender = p_Sender as DataRecordPresenter;
            if(DataRecordSender == null) return;

            DataRecord DataRecordObj = DataRecordSender.Record as DataRecord;
            if(DataRecordObj == null) return;

            DataRowView DataRowViewObj = DataRecordObj.DataItem as DataRowView;
            if(DataRowViewObj == null) return;

            // Do the expanding of everything at the batch level
            if(DataRowViewObj.Row.Table.TableName != "Batch") return;

            // Expands everything if 
            // not already expanded
            bool FlagRecursive = true;
            if (!DataRecordSender.Record.IsExpanded)  
            {  ((DataRecordSender).DataPresenter as XamDataGrid).Records.ExpandAll(FlagRecursive);  }
        }
        
        

        /// <summary>
        /// A hyperlink is clicked to enter tolerance notes.
        /// </summary>
        private void TextBlockToleranceNotesEntry_RequestNavigate(object p_Sender, RequestNavigateEventArgs p_Args)
        {
          

        }

        /// <summary>
        /// Editing is starting.
        /// </summary>
        private void m_Grid_EditModeStarting(object p_Sender, Infragistics.Windows.DataPresenter.Events.EditModeStartingEventArgs p_Args)
        {
 
        }
        
        /// <summary>
        /// Editing has started.
        /// </summary>
        private void m_Grid_EditModeStarted(object p_Sender, Infragistics.Windows.DataPresenter.Events.EditModeStartedEventArgs p_Args)  {    }


        /// <summary>
        /// When checkboxes in the grid are changed.
        /// </summary>
        private void m_Grid_ValueChanged(object p_Sender, RoutedPropertyChangedEventArgs<object> p_Args)
        {
            // We only handle checkboxes at this time.
            Infragistics.Windows.Editors.XamCheckEditor OriginalSource;
            OriginalSource = p_Args.OriginalSource as Infragistics.Windows.Editors.XamCheckEditor;
            if(OriginalSource == null) return;

            // Don't force end
            // (allow cancel)
            bool Force = false;
            bool AcceptChanges = true;
            OriginalSource.EndEditMode(AcceptChanges, Force);

            // Nothing else
            p_Args.Handled = true;
        }

        /// <summary>
        /// Continuing after a warning for a specific run number.
        /// </summary>
        private void ContinuationEntry_RequestNavigate(object p_Sender, RequestNavigateEventArgs p_Args)
        {
            
        }

        /// <summary>
        /// Check inventory.
        /// </summary>
        private void InventoryCheckEntry_RequestNavigate(object p_Sender, RequestNavigateEventArgs p_Args)
        {
            

        }

        private void xamDataPresenter1_AssigningFieldLayoutToItem(object sender, Infragistics.Windows.DataPresenter.Events.AssigningFieldLayoutToItemEventArgs e)
        {

        }

        private void xamDataPresenter1_AssigningFieldLayoutToItemDirect(object sender, Infragistics.Windows.DataPresenter.Events.AssigningFieldLayoutToItemEventArgs e)
        {

        }

        private void xamDataPresenter1_FieldLayoutInitializing(object sender, Infragistics.Windows.DataPresenter.Events.FieldLayoutInitializingEventArgs e)
        {
            
        }

        private void xamDataPresenter1_FieldLayoutInitialized(object sender, Infragistics.Windows.DataPresenter.Events.FieldLayoutInitializedEventArgs e)
        {
            System.Diagnostics.Debug.WriteLine("Message  " + e.FieldLayout.Key.ToString());

        }



         

    }
}
